CON
  _clkmode = xtal1 + pll16x
  _CLKFREQ = 80_000_000      

  
OBJ

  FM       :   "FM Radio Receiver"           ' FM Radio Receiver Module Object                      
  Buttons  :   "Touch Buttons"               ' Touch Button object


VAR

  byte vol                                   ' Store volume level 
 
PUB Main

  FM.Initialize(8, 9)                        ' Start FM Radio object
  FM.SeekThreshold(6)                        ' Set seek threshold
  FM.VolumeSet(1)                            ' Set volume level to 1 

  dira[23..16]~~                             ' Set LEDs to outputs

  Buttons.start(_CLKFREQ / 100)              ' Start button object
 
  repeat                        
    outa[23..16] := Buttons.State
    if Buttons.State == %10000000            ' If the P7 button is touched,
      FM.SeekDown                            ' auto seek down for a station
    if Buttons.State == %01000000            ' If the P6 button is touched,
      FM.SeekUp                              ' auto seek up for a station
    if Buttons.State == %00100000            ' If the P5 button is touched,
      FM.VolumeDown                          ' turn the volume down
    if Buttons.State == %00010000            ' If the P4 button is touched, 
      FM.VolumeUp                            ' turn the volume up
    if Buttons.State == %00001000            ' If the P3 button is touched,
      vol := FM.CheckVolume                  ' Store current volume level   
      LedVol                                 ' Call LedVol Method
      outa[23..16]~                          ' Turn LEDs off
           
    waitcnt(clkfreq/4 + cnt)                 ' Short pause

   
PUB LedVol
'' Turns LEDs on based on volume level, maximum 15
  
  outa[23..16]~                              ' Turn any LEDs off
     
  case vol                                   ' Select current volume level
    1..2   : outa[23]~~                      ' Up to level 2, P23 LED on           
    3..4   : outa[23..22]~~                  ' Up to level 4, P22-23 LEDs on 
    5..6   : outa[23..21]~~                  ' Up to level 6, P21-23 LEDs on
    7..8   : outa[23..20]~~                  ' Up to level 8, P20-23 LEDs on
    9..10  : outa[23..19]~~                  ' Up to level 10, P19-23 LEDs on
    11..12 : outa[23..18]~~                  ' Up to level 12, P18-23 LEDs on
    13..14 : outa[23..17]~~                  ' Up to level 13, P17-23 LEDs on
    15     : outa[23..16]~~                  ' Level 15, all LEDs on

  waitcnt(clkfreq + cnt)                     ' Keep LEDs on for some time
      
  