CON
  _clkmode = xtal1 + pll16x
  _CLKFREQ = 80_000_000      

  'SDA = 0                                    ' SDA connected to P0
  'SCL = 1                                    ' SCL connected to P1

  SDA = 8                                    ' SDA connected to P8
  SCL = 9                                    ' SCL connected to P9
  
OBJ

  FM       :   "FM Radio Receiver"           ' FM Radio Receiver Module Object                      
  Buttons  :   "Touch Buttons"               ' Touch Button object
  'pst      :   "Parallax Serial Termial"
  pst      :   "Parallax Serial Terminal"  

VAR

  byte vol                                   ' Store volume level 


PUB Main

  pst.start(57600)

  FM.Initialize(SDA,SCL)                     ' Start FM Radio object
  FM.SeekThreshold(6)                        ' Set seek threshold
  FM.VolumeSet(1)                            ' Set volume level to 1 

  dira[23..16]~~                             ' Set LEDs to outputs

  Buttons.start(_CLKFREQ / 100)              ' Start button object
    
  repeat
    outa[23..16] := Buttons.State
    pst.home
    pst.bin(Buttons.State, 8)
    ifnot ina[7]                             ' If the P7 button is touched,
      FM.SeekDown                              ' auto seek for a station
    elseifnot ina[6]
      FM.SeekUp
    elseifnot ina[5]                             ' If the P6 button is touched,
      FM.VolumeDown                          ' turn the volume down
    elseifnot ina[4]                             ' If the P5 button is touched, 
      FM.VolumeUp                            ' turn the volume up
    elseifnot ina[3]                             ' If the P4 button is touched,
      vol := FM.CheckVolume                    ' Store current volume level   
      LedVol                                 ' increase radio frequency by 0.1 MHz
      outa[23..16]~                          ' Use LEDs for volume feedback 
    elseifnot ina[2]                             ' If the P3 button is touched, 
      FM.FreqDown                            ' decrease radio frequency by 0.1 MHz       
    else        
      waitcnt(clkfreq/4 + cnt)                 ' Short pause

   
PUB LedVol
'' Turns LEDs on based on volume level, maximum 15
  
  outa[23..16]~
     
  case vol                                   ' Select current volume level
    1..2   : outa[23]~~                      ' Up to level 2, P23 LED on           
    3..4   : outa[23..22]~~                  ' Up to level 4, P22-23 LEDs on 
    5..6   : outa[23..21]~~                  ' Up to level 6, P21-23 LEDs on
    7..8   : outa[23..20]~~                  ' Up to level 8, P20-23 LEDs on
    9..10  : outa[23..19]~~                  ' Up to level 10, P19-23 LEDs on
    11..12 : outa[23..18]~~                  ' Up to level 12, P18-23 LEDs on
    13..14 : outa[23..17]~~                  ' Up to level 13, P17-23 LEDs on
    15     : outa[23..16]~~                  ' Level 15, all LEDs on

  waitcnt(clkfreq + cnt)
      
  